@import "sass-essentials";

$bp-s: 500px;
$bp-m: 800px;
.form-checkboxes {
  .form-item {
    margin-bottom: 0.5rem;
    &:last-child {
      margin-bottom: 0;
    }
  }
}

.form-item--checkbox {
  margin-bottom: 20px;
  display: flex;
  flex-direction: column;
  text-align: left;
  .form-item__label {
    order: 0;
    margin-bottom: 0;
  }
  &.form-item--error {
    .form-item__label {
      //color: $red;
    }
  }
  label.error {
    order: 2;
  }
  .description {
    order: 4;
  }
}

input[type="checkbox"] {
  position: absolute;
  width: 18px;
  height: 18px;
  opacity: 0;
  ~ .form-item__label {
    label {
      position: relative;
      min-height: 20px;
      margin-bottom: 0;
      padding-left: 32px;
      display: flex;
      flex-direction: column;
      cursor: pointer;
    }
    .label-text {
      flex: 0 0 auto;
      margin: auto 0;
      position: relative;
      top: -1px;
      font-size: 21px;
      line-height: 20px;
      font-weight: normal;
      @media(min-width: $bp-s) {
        padding-right: 30px;
      }
      @media(min-width: $bp-m) {
        padding-right: 70px;
      }
    }
    .label-date {
      font-weight: lighter;
      margin-right: -90px; // To override .label-text padding-right. @todo: don't do this.

      &:before {
        content: ' - ';
      }

      @media(min-width: $bp-s) {
        float: right;

        &:before {
          content: none;
        }
      }
    }
    .label-helper {
      content: '';
      display: inline-block;
      height: 18px;
      width: 18px;
      border: 1px solid #D8D8D8;
      margin-right: 10px;
      transition: background-color 0.2s ease;
      background-size: 80%;
      background-position: top right 2px;
      position: absolute;
      top: 0;
      left: 0;
      background-color: #FFF;
      background-image: url('check.svg');
      background-position: center center;
      background-repeat: no-repeat;
      border-radius: 4px;
      background-size: 13px;
      .form-item--error & {
        border-color: red;
      }
    }
    .switcher-helper {
      position: absolute;
      top: 50%;
      right: 0;
      width: 56px;
      transform: translateY(-50%);
      transition: all 0.3s ease;
      opacity: 1;
      &:before,
      &:after {
        content: "";
        position: absolute;
        margin: 0;
        outline: 0;
        overflow: hidden;
        top: 50%;
        transform: translate(0, -50%);
        transition: all 0.3s ease;
      }
      &:before {
        left: 1px;
        width: 58px;
        height: 25px;
        background-color: #DEDEDE;
        border-radius: 18px;
        box-shadow: inset 0px 1px 3px 0px rgba(0, 0, 0, 0.5);
      }
      &:after {
        left: 0;
        width: 25px;
        height: 25px;
        background-color: #464646;
        border-radius: 50%;
        box-shadow: 0 3px 1px -2px rgba(0, 0, 0, 0.14), 0 2px 2px 0 rgba(0, 0, 0, 0.098), 0 1px 5px 0 rgba(0, 0, 0, 0.084);
      }
    }
  }
  ~ .form-item__label--switcher {
    margin-right: 0;
    label {
      padding-right: 58px;
      padding-left: 0;
    }
  }
  &:disabled {
    ~ .form-item__label {
      .label-helper {
        background-color: #CCC;
      }
    }
    ~ .form-item__label--switcher {
      .switcher-helper:after {
        background-color: #CCC;
      }
    }
    &:checked {
      ~ .form-item__label {
         .label-helper {
          opacity: 0.6;
        }
      }
      ~ .form-item__label--switcher {
        .switcher-helper {
          opacity: 0.6;
        }
      }
    }
  }
  &:hover,
  &:focus {
    ~ .form-item__label {
      .label-helper {
        border-color: #BBB;
      }
    }
  }
  &:checked {
    ~ .form-item__label {
      .label-helper {
        background-color: #666;
      }
    }
    ~ .form-item__label--switcher {
      .switcher-helper {
        &:before {
          background-color: #AAA;
        }
        &:after {
          background-color: #555;
          transform: translate(132%, -50%);
        }
      }
    }
  }
}
